#define F_CPU 16000000L
#include <avr/io.h>
#include <util/delay.h>
#include "UART0.h"

#define set_bit(value, bit) ( _SFR_BYTE(value) |= _BV(bit) )
#define clear_bit(value, bit) ( _SFR_BYTE(value) &= ~_BV(bit) )

int main(void) {
  UART0_init();       // UART 시리얼 통신 초기화
  clear_bit(DDRD, 1);     // 버튼 연결 핀을 입력으로 설정
  set_bit(PORTD, 1);      // 내장 풀업 저항 사용 설정

  set_bit(DDRE, 3);     // LED 연결 핀을 출력으로 설정

  while (1) {
    uint8_t state = PIND & 0x01;    // 버튼 상태 읽기
    // 풀업 저항을 사용하므로 버튼 상태와 반대로 LED에 표시
    if (!state) set_bit(PORTE, 3);
    else clear_bit(PORTE, 3);

    UART0_print(!state);      // 시리얼 모니터로 LED 상태 출력
    UART0_write('\n');

    _delay_ms(500);
  }

  return 0;
}
