#define F_CPU 16000000UL
#include <avr/io.h>
#include <util/delay.h>
#include <avr/interrupt.h>

#define set_bit(value, bit) ( _SFR_BYTE(value) |= _BV(bit) )
#define clear_bit(value, bit) ( _SFR_BYTE(value) &= ~_BV(bit) )

volatile uint8_t state = 0;      // LED의 상태

ISR(PCINT1_vect) {
  state = !state;       // LED 상태 전환
}

void PCINT1_init(void) {
  PCICR |= (1 << PCIE1);      // 핀 변화 인터럽트 1 허용
  PCMSK1 |= (1 << PCINT9);    // PJ0 핀의 핀 변화 인터럽트 허용
  sei();              // 전역적으로 인터럽트 허용
}

int main(void) {
  PCINT1_init();        // INT0 인터럽트 설정
  clear_bit(DDRJ, 0);     // 버튼 연결 핀을 입력으로 설정
  set_bit(DDRE, 5);     // LED 연결 핀을 출력으로 설정

  while (1) {
    if (state) set_bit(PORTE, 5);
    else clear_bit(PORTE, 5);
  }

  return 0;
}
