#define F_CPU 16000000L
#include <avr/io.h>
#include <util/delay.h>

#define set_bit(value, bit) ( _SFR_BYTE(value) |= _BV(bit) )
#define clear_bit(value, bit) ( _SFR_BYTE(value) &= ~_BV(bit) )

int main(void) {
  set_bit(DDRB, 7);     // PB7 핀을 출력으로 설정
  clear_bit(PORTB, 7);      // LED는 끈 상태로 시작

  uint8_t state = 0;      // LED 상태

  while (1) {
    state = !state;       // LED 상태 반전
    if (state) set_bit(PORTB, 7);   // LED 켜기
    else clear_bit(PORTB, 7);   // LED 끄기
    _delay_ms(1000);      // 1초 지연
  }

  return 0;
}
