#define F_CPU 16000000L
#include <avr/io.h>
#include <util/delay.h>

#define set_bit(value, bit) ( _SFR_BYTE(value) |= _BV(bit) )
#define clear_bit(value, bit) ( _SFR_BYTE(value) &= ~_BV(bit) )

int main(void) {
  set_bit(DDRE, 4);     // PB4 핀을 출력으로 설정
  set_bit(DDRE, 5);       // PB5 핀을 출력으로 설정
  clear_bit(PORTJ, 0);      // PJ0 핀을 입력으로 설정

  clear_bit(PORTE, 4);      // PB4 핀에 연결된 LED를 끈 상태로 시작
  clear_bit(PORTE, 5);      // PB5 핀에 연결된 LED를 끈 상태로 시작

  uint8_t state1 = 0, state2;     // LED 상태

  while (1) {
    state1 = !state1;       // LED1 상태 반전
    if (state1) set_bit(PORTE, 4);    // LED1 켜기
    else clear_bit(PORTE, 4);     // LED1 끄기
    _delay_ms(1000);      // 1초 지연

    state2 = PINJ & 0x01;   // 버튼 상태 읽기
    if (state2) set_bit(PORTE, 5);    // LED2 켜기
    else clear_bit(PORTE, 5);     // LED2 끄기
  }

  return 0;
}
